{#############################################################################
#                _         _                  _____                          #
#               | |       | |                / __  \                         #
#      ___  ___ | | _____ | |__   __ _ _ __  `' / /'                         #
#     / __|/ _ \| |/ / _ \| '_ \ / _` | '_ \   / /                           #
#     \__ \ (_) |   < (_) | |_) | (_| | | | |./ /___                         #
#     |___/\___/|_|\_\___/|_.__/ \__,_|_| |_|\_____/                         #
#                                                                            #
#  Kohn's Sokoban2                                                           #
#                                                                            #
#  Copyright (C) 2001  Norman Krebs                                          #
#                                                                            #
#    This program is free software; you can redistribute it and/or           #
#    modify it under the terms of the GNU General Public License as          #
#    published by the Free Software Foundation; either version 2 of          #
#    the License, or (at your option) any later version.                     #
#                                                                            #
#    This program is distributed in the hope that it will be useful,         #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of          #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        #
#    General Public License for more details.                                #
#                                                                            #
#    You should have received a copy of the GNU General Public License       #
#    along with this program; if not, write to the Free Software             #
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
#                                                                            #
#############################################################################}
unit Unit1;

{
0
1 back
2 dialense
3 diamond
4 lense
5 man
6 manlense
7 none
8 stone
Tmemo
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls, registry, shellapi, FileCtrl;

const
    version = '0.92.081';
    _idstr_ = 'Kohns Sokoban2';
    _built_ = 'Freitag, 15. Oktober 2004  11:20:58.847 / Delphi 7 [on POLLUX]';

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    Rooms1: TMenuItem;
    Edit1: TEdit;
    Panel2: TPanel;
    Image2: TImage;
    Image3: TImage;
    Info1: TMenuItem;
    About1: TMenuItem;
    Game1: TMenuItem;
    Quit1: TMenuItem;
    Animation1: TMenuItem;
    Timer1: TTimer;
    Undo1: TMenuItem;
    Reload1: TMenuItem;
    Layouts1: TMenuItem;
    N1: TMenuItem;
    Help1: TMenuItem;
    Next1: TMenuItem;
    Previous1: TMenuItem;
    Bookmarks1: TMenuItem;
    Add1: TMenuItem;
    N3: TMenuItem;
    Remove1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Choose1: TMenuItem;
    roominf1: TMenuItem;
    N5: TMenuItem;
    New1: TMenuItem;
    Size1: TMenuItem;
    Logging1: TMenuItem;
    SaveSteps1: TMenuItem;
    SaveDialog1: TSaveDialog;
    PaintBox1: TPaintBox;
    procedure loadroomstomenu;
    procedure loadbmpstomenu;
    procedure loadbookmarkstomenu;
    procedure loadbackground;
    procedure selectroom;
    procedure BookmarkPopMenuHandler(sender : Tobject);
    procedure BookmarkREMPopMenuHandler(sender : Tobject);
    procedure RoomPopMenuHandler(sender : Tobject);
    procedure BmpsPopMenuHandler(sender : Tobject);
    procedure loadbmps;
    procedure drawelement(x, y, p : integer);
    procedure drawallelements;
    procedure FormDestroy(Sender: TObject);
    procedure drawbackground;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Quit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Animation1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure undo;
    procedure Reload1Click(Sender: TObject);
    procedure reload;
    procedure Help1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure loadprev;
    procedure loadnext(a : integer);
    procedure Next1Click(Sender: TObject);
    procedure Previous1Click(Sender: TObject);
    procedure jump(x, y : integer; button : TmouseButton);
    function loadroom2 : boolean;
    procedure loadrooms;
    procedure loadsingleroom;
    function getcoll : integer;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Add1Click(Sender: TObject);
    procedure roominf1Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure New1Click(Sender: TObject);
    procedure newgame;
    procedure Size1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Logging1Click(Sender: TObject);
    procedure SaveSteps1Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

  Txy = record
          x, y : integer;
        end;

  Txyw = record
           a : array[1..4] of record x, y, w : integer; end;
           c : char;
         end;

  Treached = record
               a : integer;
               s : string;
             end;

  Troom = record
    x, y : integer;
    r : array[0..51, 0..51] of integer;
  end;

  Tray = array[1..1000] of Troom;

  Ttext = text;

const
  roomdir : string = 'rooms\';
  bmpsdir : string = 'bmp\';
  mainbckfilename = 'bmp\background.bmp';
  roomselected : boolean = false;

  MAXUNDOLIST = 100000;

var
  Form1 : TForm1;
  Cstonesize : Txy;
  history : array[0..MAXUNDOLIST] of Txyw;
  steplist : array [0..MAXUNDOLIST] of char;
  stepfilename, bookmarkfilename, bookmarkdir, workdir, roomtitle : string;
  i, j : integer;
  rb_, rb2_, jb_, roomlastboard : array[1..50, 1..50] of integer;
  rct : integer;
  ray : Tray;
  stepfile, bookmarkfile, roomfile : text;
  maincnt, roomnr, oldroom : integer;
  act, roomlastsize : Txy;
  gljmp : boolean;
  dest, srce : Txy;
  regfile : TregIniFile;
  reached : array[0..1000] of Treached;
  winver, winsubver, buildnr : integer;
  w31, w95, wnt, w2k : boolean;
  bookmarks : array[0..100] of string;
  _OUT_SIZER : real = 1;
  lastdraw : DWORD;


procedure outc(s : string);
procedure infoout;
function get_user_name: string;
procedure getWindowsVersion(var winver, winsubver, buildnr : integer; var win31, win95, winnt, win2k : boolean);

implementation

uses Unit2, Unit3, Unit4, Unit5;

{$R *.DFM}

function del_and_(s : string) : string;
begin
  result:= s;
  while pos('&', result) <> 0 do delete(result, pos('&', result), 1);
end;

function direxists(nd : string) : boolean;
var od : string;
begin
  getdir(0, od);
  {$I-}
  chdir(nd);
  result:= (ioresult = 0);
  chdir(od);
end;

procedure errorhalt(s : string; errno : integer);
begin
  MessageDlg('Sokoban2 Error[' + inttostr(errno) + ']: ' + s, mtError, [mbOk], 0);
  halt;
end;

procedure getWindowsVersion(var winver, winsubver, buildnr : integer; var win31, win95, winnt, win2k : boolean);
var o : TOSVERSIONINFO;
//    s : string;
//    c : char;
begin
  o.dwOSVersionInfoSize:= sizeof(o);
  if getversionex(o) then begin
    winver:= o.dwmajorversion;
    winsubver:= o.dwminorversion;
    buildnr:= o.dwBuildNumber;

{
    outc('getwindowsversion');
    outc('dwOSVersionInfoSize ' + inttostr(o.dwOSVersionInfoSize));
    outc('dwMajorVersion ' + inttostr(o.dwMajorVersion));
    outc('dwMinorVersion ' + inttostr(o.dwMinorVersion));
    outc('dwBuildNumber ' + inttostr(o.dwBuildNumber));
    outc('dwPlatformId ' + inttostr(o.dwPlatformId));
    s:= '';
    for i:= 1 to 20 do begin
      c:= o.szCSDVersion[i];
      s:= s + c;
    end;

    outc(s);

    outc('VER_PLATFORM_WIN32s        ' + inttostr(VER_PLATFORM_WIN32s));
    outc('VER_PLATFORM_WIN32_WINDOWS ' + inttostr(VER_PLATFORM_WIN32_WINDOWS));
    outc('VER_PLATFORM_WIN32_NT      ' + inttostr(VER_PLATFORM_WIN32_NT));
{}

    win31:= false;
    win95:= false;
    winnt:= false;
    win2k:= false;

    case o.dwplatformid of
      VER_PLATFORM_WIN32_WINDOWS : win95:= true;
      VER_PLATFORM_WIN32_NT : winnt:= true;
      VER_PLATFORM_WIN32s : win31:= true;

    end;
  end;
end;

function b_p(s : string) : string;
var ss : string;
begin
  ss:= s;
  result:= copy(ss, 1, pos('_', ss) - 1);
  delete(ss, 1, pos('_', ss));
  result:= result + ' #' + copy(ss, 1, pos('_', ss) - 1);
  delete(ss, 1, pos('_', ss));
  result:= result + ' (' + copy(ss, 1, pos('.', ss) - 1) + ')';
end;

function p_b(s : string) : string;
var i : integer;
begin
  for i:= 1 to length(s) do
    if s[i] = ' ' then s[i]:= '_';
  delete(s, pos('#', s), 1);
  delete(s, pos('(', s), 1);
  delete(s, pos(')', s), 1);
  s:= s + '.txt';
  result:= s;
end;

function StrPas(const Str: PChar): string; begin Result:= Str; end;

function get_user_name: string;
var
  Buffer: Array[0..MAX_PATH + 1] of Char;
  Size: LONGWORD;
begin
  size:=1024;
  GetUserName(Buffer, Size);
  Result:= StrPas(Buffer);
end;

procedure showhelp;
begin
  if fileexists(workdir + 'html\index.html') then
    ShellExecute(Application.Handle, nil, pchar(workdir + 'html\index.html'), nil, nil, SW_SHOWNOACTIVATE)
  else
    MessageDlg('helpfile not found!', mtInformation, [mbOk], 0);
end;

procedure showinternals;
begin
  form2.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  getdir(0, workdir);
  if workdir[length(workdir)] <> '\' then workdir:= workdir + '\';
  form1.paintbox1.left:= 0;
  form1.paintbox1.top:= 0;
  form1.paintbox1.width:= form1.panel1.width;
  form1.paintbox1.height:= form1.panel1.height;

  form1.panel1.bevelouter:= bvnone;
  form1.edit1.left:= 1;
  form1.edit1.top:= 1;
  form1.edit1.width:= 0;
  form1.panel2.left:= 1;
  form1.panel2.top:= 1;
  form1.panel2.width:= 0;
  form1.AutoSize:= true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var a, i : integer;
begin
  regfile:= TregIniFile.create('system');
  regfile.rootkey:= HKEY_CURRENT_USER;
  regfile.Createkey('\Software\NKsoftware\sokoban2');
  regfile.WriteString('\Software\NKsoftware\sokoban2','left',inttostr(form1.left));
  regfile.WriteString('\Software\NKsoftware\sokoban2','top', inttostr(form1.top));
  regfile.WriteString('\Software\NKsoftware\sokoban2','size', floattostr(_OUT_SIZER));
  if Form1.Logging1.Checked then
    regfile.WriteString('\Software\NKsoftware\sokoban2','Logging', '1')
  else
    regfile.WriteString('\Software\NKsoftware\sokoban2','Logging', '0');
  if Form1.SaveSteps1.Checked then
    regfile.WriteString('\Software\NKsoftware\sokoban2','SaveSteps', '1')
  else
    regfile.WriteString('\Software\NKsoftware\sokoban2','SaveSteps', '0');
{
  regfile.WriteString('\Software\NKsoftware\sokoban2','f2left',inttostr(form2.left));
  regfile.WriteString('\Software\NKsoftware\sokoban2','f2top', inttostr(form2.top));
  regfile.WriteString('\Software\NKsoftware\sokoban2','f2width',inttostr(form2.width));
  regfile.WriteString('\Software\NKsoftware\sokoban2','f2height', inttostr(form2.height));
{}

  for i:= 0 to layouts1.Count - 1 do
    if layouts1.items[i].checked then begin
      regfile.WriteString('\Software\NKsoftware\sokoban2','Layout', inttostr(i));
      break;
    end;

  if animation1.checked then
    regfile.WriteString('\Software\NKsoftware\sokoban2', 'animation', '1')
  else
    regfile.WriteString('\Software\NKsoftware\sokoban2', 'animation', '0');

//ROOMS
  for i:= 0 to rooms1.Count - 1 do begin
    a:= strtoint(regfile.ReadString('\Software\NKsoftware\sokoban2\rooms', del_and_(form1.rooms1.items[i].caption), '0'));
    if a < Reached[i].a then
      regfile.WriteString('\Software\NKsoftware\sokoban2\rooms', del_and_(rooms1.items[i].caption), inttostr(Reached[i].a));
  end;

  for i:= 0 to rooms1.Count - 1 do
    if rooms1.items[i].checked then begin
      regfile.WriteString('\Software\NKsoftware\sokoban2','Room', del_and_(rooms1.items[i].caption));
      break;
    end;
  regfile.Free;
end;

function emptyline(s : string) : boolean;
var i : integer;
begin
  result:= true;
  for i:= 1 to length(s) do
    if s[i] <> ' ' then result:= false;
end;

function istitle(s : string) : boolean;
var i : integer;
begin
  result:= false;
  for i:= 1 to length(s) do
    if pos(s[i], #0 + ' #*.$@+') = 0 then result:= true;
end;

//==========================AUSGABE============================================================
//==========================AUSGABE============================================================

procedure infoout;
var s1, s2, s3 : string;
    var i : integer;
begin
//  form1.label1.left:= 10;
//  form1.label1.top:= form1.panel1.height - 17;

//  form1.label1.visible:= false;

  for i:= 0 to form1.rooms1.count - 1 do
    if form1.rooms1.items[i].checked then begin
      s1:= inttostr(reached[i].a);
      break;
    end;

//  form1.label1.caption:= 'Room: ' + inttostr(roomnr) + '/' + s1 + '/' + inttostr(rct) + '   Steps: ' + inttostr(maincnt);

  s1:= inttostr(roomnr);
//  while length(s1) < 3 do s1:= ' ' + s1;
  s2:= inttostr(rct);
//  while length(s2) < 3 do s2:= ' ' + s2;
  s3:= inttostr(maincnt);
//  while length(s3) < 3 do s3:= ' ' + s3;
  form1.roominf1.caption:= s1 + '/' + s2 + '/' + s3;

end;

procedure tform1.drawallelements;
var i, j : integer;
begin
  outc('drawallelements();');
  for j:= 1 to 50 do
    for i:= 1 to 50 do
      drawelement(trunc(Cstonesize.x * _OUT_SIZER) * (i - 1), trunc(Cstonesize.y * _OUT_SIZER) * (j - 1), rb_[i, j]);
end;

procedure Tform1.drawelement(x, y, p : integer);
var MyRect, MyOther : TRect;
begin
  if p = 0 then p:= 7;
  if p in [1..8] then begin
    MyRect:= Rect((p - 1) * Cstonesize.x + p, 1, (p) * Cstonesize.x + p, Cstonesize.y + 1);
    MyOther:= Rect(x, y, x + trunc(Cstonesize.x * _OUT_SIZER), y + trunc(Cstonesize.y * _OUT_SIZER));
    form1.paintbox1.Canvas.CopyRect(MyOther, form1.image2.Canvas, MyRect);
  end;
end;

procedure tform1.drawbackground;
var MyRect, MyOther : TRect;
begin
  MyRect:= Rect(0, 0, image3.Width, image3.height);
  MyOther:= Rect(0, 0, image3.Width, image3.height);
  form1.paintbox1.Canvas.CopyRect(MyOther, form1.image3.Canvas, MyRect);
end;

procedure outc(s : string);
var ss : string;
begin
  ss:= inttostr(maincnt);
  if showlinenumbers then begin
    while length(ss) < 3 do ss:= '0' + ss;
    ss:= ss + ' ';
    s:= ss + s;
  end;
  if form1.Logging1.Checked then begin
    form2.richedit1.lines.add(s);
    form2.richedit1.selstart:= length(form2.richedit1.Text);
    form2.richedit1.sellength:= 0;
  end;
{
  if form2.richedit1.Lines.Count >= 2000 then begin
    if ( form2.richedit1.Lines.Count mod 2000 ) = 0 then begin
      if MessageDlg('The console contains now ' +
                    inttostr(form2.richedit1.Lines.Count) +
                    ' lines. Do You like to clear it?' ,
                    mtConfirmation,
                    [mbYes, mbNo], 0) = mrYes then
        form2.richedit1.Clear;
    end;
  end;
{}
end;

//==========================VERTEILER=========================================================
//==========================VERTEILER=========================================================

function readline(var a : Ttext; s : string) : string;
var lne : string;
begin
  reset(a);
  result:= '';
  while not eof(a) do begin
    readln(a, lne);
    if pos(s, lne) <> 0 then begin
      delete(lne, 1, pos('=', lne));
      result:= lne;
    end;
  end;
end;

procedure senddrawmessage;
begin
  if (gettickcount - lastdraw) > 100 then form1.drawallelements
  else lastdraw:= gettickcount;
end;

procedure Tform1.BookmarkPopMenuHandler(sender : Tobject);
var i, j : integer;
    lne, s : string;
    flag : boolean;
begin
  with Sender as TMenuItem do begin
    lne:= caption;
  end;
  for i:= 0 to choose1.Count - 1 do
    if lne = choose1.items[i].caption then begin
      bookmarkfilename:= bookmarks[i];
      break;
    end;
  outc('found bookmarkfilename ' + bookmarkfilename);
  assignfile(bookmarkfile, bookmarkdir + bookmarkfilename);
  reset(bookmarkfile);

  lne:= readline(bookmarkfile, 'roomfilename');

  flag:= false;
  for i:= 0 to rooms1.Count - 1 do rooms1.items[i].checked:= false;

  for i:= 0 to rooms1.Count - 1 do begin
    s:= rooms1.items[i].caption;
    while pos('&', s) <> 0 do delete(s, pos('&', s), 1);
//    outc('########## ' + s + '  ' + lne);
    if s = lne then begin
      flag:= true;
      rooms1.items[i].checked:= true;
      break;
    end;
  end;
  if not flag then begin
    MessageDlg('Room collection file: ' + lne + ' not found', mtInformation, [mbOk], 0);
  end
  else begin
    roomselected:= false;

    roomnr:= strtoint(readline(bookmarkfile, 'roomnr'));
    outc('roomnr ' + inttostr(roomnr));

    form1.loadrooms;
    form1.loadsingleroom;

    maincnt:= strtoint(readline(bookmarkfile, 'maincnt'));
    outc('maincnt ' + inttostr(maincnt));

    for j:= 1 to 50 do
      for i:= 1 to 50 do
        rb_[i, j]:= 0;

    reset(bookmarkfile);
    repeat readln(bookmarkfile, lne); until (pos('#', lne) <> 0) and (pos('itemname', lne) = 0);

    j:= 2;
    outc(inttostr(j) + '  ' + lne);
    for i:= 1 to length(lne) do begin
      case ord(lne[i]) of
          ord(' ') : rb_[i, j]:= 1; // Back
          ord('*') : rb_[i, j]:= 2; // Diamant+Linse
          ord('$') : rb_[i, j]:= 3; // Diamant
          ord('.') : rb_[i, j]:= 4; // Linse
          ord('@') : begin rb_[i, j]:= 5; act.x:= i; act.y:= j; end;// Mann
          ord('+') : begin rb_[i, j]:= 6; act.x:= i; act.y:= j; end;// Mann+Linse
          ord('_') : rb_[i, j]:= 7; // None
          ord('#') : rb_[i, j]:= 8; // Stein
      end;
    end;

    for j:= 3 to ray[roomnr].y do begin
      readln(bookmarkfile, lne);
      outc(inttostr(j) + '  ' + lne);
      for i:= 1 to length(lne) do begin
        case ord(lne[i]) of
          ord(' ') : rb_[i, j]:= 1; // Back
          ord('*') : rb_[i, j]:= 2; // Diamant+Linse
          ord('$') : rb_[i, j]:= 3; // Diamant
          ord('.') : rb_[i, j]:= 4; // Linse
          ord('@') : begin rb_[i, j]:= 5; act.x:= i; act.y:= j; end;// Mann
          ord('+') : begin rb_[i, j]:= 6; act.x:= i; act.y:= j; end;// Mann+Linse
          ord('_') : rb_[i, j]:= 7; // None
          ord('#') : rb_[i, j]:= 8; // Stein
        end;
      end;
    end;
    for i:= 0 to maincnt - 1 do begin
      readln(bookmarkfile, lne);
      outc(lne);

// 0  1:[7,5]=5 2:[7,4]=1 3:[7,3]=1 4:[1,1]=0 u
      for j:= 1 to 4 do begin
        delete(lne, 1, pos('[', lne));
//        outc(copy(lne, 1, pos(',', lne) - 1));
        history[i].a[j].x:= strtoint(copy(lne, 1, pos(',', lne) - 1));

        delete(lne, 1, pos(',', lne));
//        outc(copy(lne, 1, pos(']', lne) - 1));
        history[i].a[j].y:= strtoint(copy(lne, 1, pos(']', lne) - 1));

        delete(lne, 1, pos('=', lne));
//        outc(copy(lne, 1, pos(' ', lne) - 1));
        history[i].a[j].w:= strtoint(copy(lne, 1, pos(' ', lne) - 1));
      end;
    end;
{}
    form1.panel1.width:= (ray[roomnr].x + 1) * trunc(Cstonesize.x * _OUT_SIZER);
    form1.panel1.height:= (ray[roomnr].y + 1) * trunc(Cstonesize.y * _OUT_SIZER);
    senddrawmessage;
    infoout;
  end;
  closefile(bookmarkfile);
end;

procedure Tform1.BookmarkREMPopMenuHandler(sender : Tobject);
var i : integer;
    lne : string;
begin
  with Sender as TMenuItem do begin
    lne:= caption;
  end;
  for i:= 0 to remove1.count - 1 do begin
    if remove1.items[i].caption = lne then begin
      assignfile(bookmarkfile, bookmarkdir + bookmarks[i]);
      if fileexists(bookmarkdir + bookmarks[i]) then begin
        erase(bookmarkfile);
        MessageDlg( bookmarkdir + bookmarks[i] + ' deleted!', mtInformation, [mbOk], 0);
      end
      else
        MessageDlg( bookmarkdir + bookmarks[i] + ' not exists!', mtInformation, [mbOk], 0);
    end;
  end;
  while choose1.count > 0 do choose1.Delete(choose1.count - 1);
  while remove1.count > 0 do remove1.Delete(remove1.count - 1);
  loadbookmarkstomenu;
end;

procedure Tform1.BmpsPopMenuHandler(sender : Tobject);
var i, x, y : integer;
begin
  x:= panel1.width;
  y:= panel1.height;
  with Sender as TMenuItem do begin
    for i:= 0 to layouts1.Count - 1 do begin
      layouts1.Items[i].checked:= false;
      if layouts1.Items[i].caption = caption then layouts1.Items[i].checked:= true;
    end;
    outc('BmpsPopMenuHandler(): ' + caption);
  end;
  loadbmps;
  form1.panel1.Width:= (ray[roomnr].x + 1) *  trunc(Cstonesize.x * _OUT_SIZER);
  form1.panel1.height:= (ray[roomnr].y + 1) *  trunc(Cstonesize.y * _OUT_SIZER);
  if (x = panel1.width) and (y = panel1.height) then senddrawmessage;
  infoout;
end;

procedure Tform1.RoomPopMenuHandler(sender : Tobject);
var i, x, y : integer;
begin
  x:= ray[roomnr].x;
  y:= ray[roomnr].y;

  outc('RoomPopMenuHandler(): ' + caption);
  roomselected:= false;
  with Sender as TMenuItem do begin
    for i:= 0 to rooms1.Count - 1 do begin
      rooms1.Items[i].checked:= false;
      if uppercase(del_and_(rooms1.Items[i].caption)) = uppercase(del_and_(caption)) then begin
        rooms1.Items[i].checked:= true;
        outc('RoomPopMenuHandler(): ' + del_and_(rooms1.Items[i].caption) + '  ' + del_and_(caption));
      end;
    end;
  end;

  for i:= 0 to form1.rooms1.count - 1 do
    if form1.rooms1.items[i].checked then begin
      roomnr:= reached[i].a + 1;
      break;
    end;

  form1.loadrooms;
  form1.loadsingleroom;

  if (x = ray[roomnr].x) and (y = ray[roomnr].y) then sendmessage(form1.Handle, wm_Paint, 0, 0);
  infoout;
end;

//==========================LADEPROCEDUREN====================================================
//==========================LADEPROCEDUREN====================================================

procedure Tform1.loadsingleroom;
var s : string;
    i, j : integer;
begin
  maincnt:= 0;
  for j:= 1 to 50 do begin
    s:= '';
    for i:= 1 to 50 do begin
      rb_[i, j]:= ray[roomnr].r[i, j];
      case rb_[i, j] of
        1 : s:= s + ' ';
        2 : s:= s + '*';
        3 : s:= s + '$';
        4 : s:= s + '.';
        5 : s:= s + '@';
        6 : s:= s + '+';
        7 : s:= s + '_';
        8 : s:= s + '#';
      end;
      if ray[roomnr].r[i, j] in [5, 6] then begin
        act.x:= i;
        act.y:= j;
      end;
    end;
//    if s <> '' then outc(inttostr(j) + s);
  end;
  form1.paintbox1.width:= trunc(50 * Cstonesize.x * _OUT_SIZER);
  form1.paintbox1.height:= trunc(50 * Cstonesize.y * _OUT_SIZER);
  form1.panel1.width:= (ray[roomnr].x + 1) * trunc(Cstonesize.x * _OUT_SIZER);
  form1.panel1.height:= (ray[roomnr].y + 1) * trunc(Cstonesize.y * _OUT_SIZER);
  form1.AutoSize:= true;
  outc('roomnr ' + inttostr(roomnr) + ' size ' + inttostr(ray[roomnr].x) + ',' + inttostr(ray[roomnr].y));

  for i:= 0 to rooms1.Count - 1 do
    if rooms1.Items[i].checked then begin
      form1.Caption:= 'Sokoban2 ' + del_and_(rooms1.Items[i].caption) + ' room ' + inttostr(roomnr);
      if roomnr > reached[i].a + 1 then reached[i].a:= roomnr - 1;
      break;
    end;
//  for i:= 0 to rooms1.Count - 1 do outc('reached[' + inttostr(i) + ']=' + inttostr(reached[i].a));
  roominf1.caption:= '' + inttostr(roomnr) + '/' + inttostr(rct) + '/' + inttostr(maincnt) + '';
end;

procedure Tform1.loadbmps;
var i : integer;
    s : string;
begin
  for i:= 0 to layouts1.Count - 1 do
    if layouts1.items[i].checked then begin
      s:= workdir + bmpsdir + layouts1.Items[i].caption;
      while pos('&', s) <> 0 do delete(s, pos('&', s), 1); 
      form1.Image2.Picture.LoadFromFile(s);
      outc('loadbmps(): ' + bmpsdir + layouts1.Items[i].caption);
    end;
  form1.Image2.width:= form1.Image2.Picture.width;
  form1.Image2.height:= form1.Image2.Picture.height;
  Cstonesize.x:= (form1.Image2.Picture.width - 9) div 8;
  Cstonesize.y:= form1.Image2.Picture.height - 2;
end;

procedure Tform1.loadbackground;
begin
  form1.image3.Picture.LoadFromFile(mainbckfilename);
  form1.image3.width:= form1.image3.picture.width;
  form1.image3.height:= form1.image3.picture.height;
end;

procedure tform1.loadroomstomenu;
var tsr : Tsearchrec;
    NewItem : Tmenuitem;
begin
  outc('WORKDIR ' + workdir);
  outc('ROOMDIR ' + workdir + roomdir);
  if findfirst(workdir + roomdir + '*.*', faanyfile, tsr) = 0 then begin
    if (tsr.name <> '.') and (tsr.name <> '..') then begin
      outc('loadroomstomenu() [' + tsr.name + ']');
      NewItem:= TMenuItem.Create(Self);
      NewItem.Caption:= tsr.Name;
      NewItem.OnClick:= RoomPopMenuHandler;
      Rooms1.Add(NewItem);
    end;
    while findnext(tsr) = 0 do begin
      if (tsr.name <> '.') and (tsr.name <> '..') then begin
        outc('loadroomstomenu() [' + tsr.name + ']');
        NewItem:= TMenuItem.Create(Self);
        NewItem.Caption:= tsr.Name;
        NewItem.OnClick:= RoomPopMenuHandler;
        Rooms1.Add(NewItem);
      end;
    end;
    FindClose(tsr);
    if (Rooms1.Count = 0) then errorhalt('No room-files found in room directory [' + workdir + roomdir + ']', 2);
  end
  else begin
    if (not direxists(workdir + roomdir)) then
      errorhalt('room directory [' + workdir + roomdir + '] not exists.', 1);
    errorhalt('No room-files found in room directory [' + workdir + roomdir + ']', 2);
  end;
end;

procedure tform1.loadbmpstomenu;
var tsr : Tsearchrec;
    NewItem : Tmenuitem;
begin
  outc('BMPSDIR ' + workdir + bmpsdir);
  if findfirst(workdir + bmpsdir + '*.bmp', faanyfile, tsr) = 0 then begin
    outc('loadbmpstomenu() ' + tsr.name);
    NewItem:= TMenuItem.Create(Self);
    NewItem.Caption:= tsr.Name;
    NewItem.OnClick:= BmpsPopMenuHandler;
    Layouts1.Add(NewItem);
    while findnext(tsr) = 0 do begin
      outc('loadbmpstomenu() ' + tsr.name);
      NewItem:= TMenuItem.Create(Self);
      NewItem.Caption:= tsr.Name;
      NewItem.OnClick:= BmpsPopMenuHandler;
      Layouts1.Add(NewItem);
    end;
//    Layouts1.Items[0].checked:= true;
    if (Layouts1.Count = 0) then
      errorhalt('No layout-files found in the layout directory [' + workdir + bmpsdir + ']', 4);
  end
  else begin
    if (not direxists(workdir + bmpsdir)) then errorhalt('layout directory [' + workdir + bmpsdir + '] not exists.', 3);
    errorhalt('No layout-files found in the layout directory [' + workdir + roomdir + ']', 4);
  end;
  FindClose(tsr);
end;

procedure Tform1.loadrooms;
var i, j, k : integer;
begin
  for k:= 1 to 1000 do begin
    ray[k].x:= 0;
    ray[k].y:= 0;
    for j:= 1 to 50 do
      for i:= 1 to 50 do
        ray[k].r[i, j]:= 0;
  end;
  while form1.loadroom2 do;
  outc('rct ' + inttostr(rct));
end;

procedure tform1.selectroom;
var lne, s : string;
    i : integer;
begin
  form1.paintbox1.Width:= Cstonesize.x * 50;
  form1.paintbox1.height:= Cstonesize.y * 50;
  for i:= 0 to rooms1.Count - 1 do
    if rooms1.items[i].checked then begin
      s:= roomdir + rooms1.Items[i].caption;
      while pos('&', s) <> 0 do delete(s, pos('&', s), 1);
      assignfile(roomfile, s);
      roomtitle:= rooms1.Items[i].caption;
      while pos('&', roomtitle) <> 0 do delete(roomtitle, pos('&', roomtitle), 1);
      outc('selectroom(): ' + s);
    end;
  reset(roomfile);
  while not eof(roomfile) do readln(roomfile, lne);
  closefile(roomfile);
  if pos('-end-' ,lne) = 0 then begin
    append(roomfile);
    writeln(roomfile, '-end-');
    closefile(roomfile);
  end;
  rct:= 0;
  roomselected:= true;
end;

function tform1.loadroom2: boolean;
var lne : string;
    i, j, k, m : integer;

begin
  result:= false;
  if not roomselected then begin
    selectroom;
    reset(roomfile);
  end;
  if not eof(roomfile) then begin
    form1.AutoSize:= false;
    repeat
      if not eof(roomfile) then readln(roomfile, lne);
    until (not emptyline(lne)) and (not istitle(lne) and (pos(';', lne) <> 1)) or (eof(roomfile));
    if not eof(roomfile) then begin
      j:= 1;
      inc(rct);
      while (not emptyline(lne)) or (eof(roomfile)) or (lne = '-end-') do begin
        if istitle(lne) or emptyline(lne) or (pos(';', lne) = 1) then begin
        end
        else begin
          k:= 0;
          if length(lne) > ray[rct].x then ray[rct].x:= length(lne);
          for i:= 1 to length(lne) do begin
            case ord(lne[i]) of
              ord(' ') : k:= 1; // Back
              ord('*') : k:= 2; // Diamant+Linse
              ord('$') : k:= 3; // Diamant
              ord('.') : k:= 4; // Linse
              ord('@') : k:= 5; // Mann
              ord('+') : k:= 6; // Mann+Linse
              ord('_') : k:= 7; // None
              ord('#') : k:= 8; // Stein
            end;
            ray[rct].r[i + 1, j + 1]:= k;
          end;
          inc(j);
        end;
        if not eof(roomfile) then readln(roomfile, lne);
//        outc(inttostr(rct) + '  ' + lne);
        if pos('-end-', lne) <> 0 then break;
      end;

      for k:= 1 to 50 do begin
        for i:= 1 to 50 do begin
          if (ray[rct].r[i, k] in [0..1]) then ray[rct].r[i, k]:= 0
          else break;
        end;
        for i:= 50 downto 1 do begin
          if (ray[rct].r[i, k] in [0..1]) then ray[rct].r[i, k]:= 0
          else break;
        end;

        for i:= 1 to 50 do begin
          if (ray[rct].r[k, i] in [0..1]) then ray[rct].r[k, i]:= 0
          else break;
        end;
        for i:= 50 downto 1 do begin
          if (ray[rct].r[k, i] in [0..1]) then ray[rct].r[k, i]:= 0
          else break;
        end;
      end;
      {}

      for k:= 50 downto 1 do begin
        m:= 0;
        for i:= 1 to 50 do m:= m + ray[rct].r[i, k];
        if m <> 0 then begin
          ray[rct].y:= k;
          break;
        end;
      end;

      for i:= 50 downto 1 do begin
        m:= 0;
        for k:= 1 to 50 do m:= m + ray[rct].r[i, k];
        if m <> 0 then begin
          ray[rct].x:= i;
          break;
        end;
      end;

      result:= true;
    end
    else begin
    end;
  end
  else begin
  end;
end;


//==========================EREIGNISBEHANDLUNG====================================================
//==========================EREIGNISBEHANDLUNG====================================================

procedure redo;
begin
//
end;

procedure Tform1.newgame;
var x, y : integer;
begin
  x:= ray[roomnr].x;
  y:= ray[roomnr].y;
  roomnr:= 1;
  loadsingleroom;
  if (x = ray[roomnr].x) and (y = ray[roomnr].y) then sendmessage(form1.Handle, wm_Paint, 0, 0);
  infoout;
  outc('newgame() OK roomnr ' + inttostr(roomnr));
end;

procedure Tform1.reload;
begin
  loadsingleroom;
  outc('reload()');
  infoout;
  senddrawmessage;
end;

procedure Tform1.undo;
var i : integer;
begin
  if maincnt > 0 then begin
    history[maincnt].a[1].x:= act.x;
    history[maincnt].a[1].y:= act.y;
    history[maincnt].a[1].w:= rb_[act.x, act.y];
    dec(maincnt);
    outc('undo()'
         + ' 1 [' + inttostr(history[maincnt].a[1].x) + ',' + inttostr(history[maincnt].a[1].y)
         + ']=' + inttostr(history[maincnt].a[1].w)
         + ' 2 [' + inttostr(history[maincnt].a[2].x) + ',' + inttostr(history[maincnt].a[2].y)
         + ']=' + inttostr(history[maincnt].a[2].w)
         + ' 3 [' + inttostr(history[maincnt].a[3].x) + ',' + inttostr(history[maincnt].a[3].y)
         + ']=' + inttostr(history[maincnt].a[3].w)
         + ' 4 [' + inttostr(history[maincnt].a[4].x) + ',' + inttostr(history[maincnt].a[4].y)
         + ']=' + inttostr(history[maincnt].a[4].w));
    for i:= 1 to 4 do begin
      rb_[history[maincnt].a[i].x, history[maincnt].a[i].y]:= history[maincnt].a[i].w;
      drawelement(trunc(Cstonesize.x * _OUT_SIZER) * (history[maincnt].a[i].x - 1), trunc(Cstonesize.y * _OUT_SIZER) * (history[maincnt].a[i].y - 1), history[maincnt].a[i].w);
    end;
    act.x:= history[maincnt].a[1].x;
    act.y:= history[maincnt].a[1].y;
  end
  else
    outc('undo() NOT POSSIBLE!');
  infoout;
end;

function Tform1.getcoll : integer;
var j : integer;
begin
  result:= 0;
  for j:= 0 to form1.rooms1.count - 1 do
    if rooms1.items[j].checked then begin
      result:= j;
      break;
    end;
end;

procedure Tform1.loadprev;
// var x, y : integer;
begin
//  x:= ray[roomnr].x;
//  y:= ray[roomnr].y;
  if 1 < roomnr then begin
    dec(roomnr);
    loadsingleroom;
    infoout;
    outc('loadprev() OK roomnr ' + inttostr(roomnr));
  end
  else begin
    MessageDlg('This is the first room!', mtInformation, [mbOk], 0);
    outc('loadnext() NOT POSSIBLE roomnr ' + inttostr(roomnr));
  end;
  drawallelements;
end;

procedure Tform1.loadnext(a : integer);
//var i, x, y : integer;
begin
//  x:= ray[roomnr].x;
//  y:= ray[roomnr].y;
  if (a = 1) or (paramcount > 0) then begin
    if rct > roomnr then begin
      inc(roomnr);
      loadsingleroom;
      infoout;
    end
    else
      MessageDlg('This is the last room!', mtInformation, [mbOk], 0);
  end
  else
  begin
    if rct > roomnr then begin
      i:= getcoll;
      if reached[i].a > roomnr - 1 then begin
        inc(roomnr);
        loadsingleroom;
        senddrawmessage;
        infoout;
        outc('loadnext() OK roomnr ' + inttostr(roomnr) + ' ' + inttostr(rct));
      end
      else begin
        MessageDlg('Please solve this room first!', mtInformation, [mbOk], 0);
        outc('loadnext() DENIED roomnr ' + inttostr(roomnr));
      end;
    end
    else begin
      MessageDlg('This is the last room!', mtInformation, [mbOk], 0);
      outc('loadnext() NOT POSSIBLE roomnr ' + inttostr(roomnr));
    end;
  end;
  drawallelements;
end;

function checkdiamonds : boolean;
var i, j, s, d
//    , z
    : integer;
begin
//  z:= 0;
  s:= 0;
  d:= 0;
  for j:= 1 to 50 do
    for i:= 1 to 50 do
      case rb_[i, j] of
//        2 : inc(z); //dialense
        3 : inc(s); //diamond
        4 : inc(d); //lense
        6 : inc(d); //manlense
      end;
//  outc('checkdiamonds() ' + inttostr(s) + '$ ' + inttostr(d) + '. ' + inttostr(z) + '*');
  result:= ((s = 0) and (d = 0));
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
  edit1.SetFocus;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var a, b, i : integer;
    anim : boolean;

function dothestep(d : integer) : boolean;
var x, y : integer;
    oldact : Txy;
    i : integer;
    ss : string;
begin
  x:= 0;
  y:= 0;
  case d of
    1 : begin x:= -1; y:= 0; end;
    2 : begin x:= 0; y:= -1; end;
    3 : begin x:= +1; y:= 0; end;
    4 : begin x:= 0; y:= +1; end;
  end;

  result:= false;

  if rb_[act.x + x, act.y + y] in [1, 4] then begin   //schritt

    oldact.x:= act.x;
    oldact.y:= act.y;

    history[maincnt].a[1].x:= act.x;
    history[maincnt].a[1].y:= act.y;
    history[maincnt].a[1].w:= rb_[act.x, act.y];

    history[maincnt].a[2].x:= act.x + x;
    history[maincnt].a[2].y:= act.y + y;
    history[maincnt].a[2].w:= rb_[act.x + x, act.y + y];

    history[maincnt].a[3].x:= act.x + 2 * x;
    history[maincnt].a[3].y:= act.y + 2 * y;
    history[maincnt].a[3].w:= rb_[act.x + 2 * x, act.y + 2 * y];

    history[maincnt].a[4].x:= 1;
    history[maincnt].a[4].y:= 1;
    history[maincnt].a[4].w:= rb_[1, 1];

    case d of
      1 : history[maincnt].c:= 'l';
      2 : history[maincnt].c:= 'u';
      3 : history[maincnt].c:= 'r';
      4 : history[maincnt].c:= 'd';
    end;

    if rb_[act.x, act.y] = 6 then rb_[act.x, act.y]:= 4  //manlense
    else
    rb_[act.x, act.y]:= 1;

    if rb_[act.x + x, act.y + y] = 4 then rb_[act.x + x, act.y + y]:= 6 //linse?
    else
    rb_[act.x + x, act.y + y]:= 5;

    drawelement(trunc(Cstonesize.x * _OUT_SIZER) * (act.x - 1), trunc(Cstonesize.y * _OUT_SIZER) * (act.y - 1), rb_[act.x, act.y]);
    drawelement(trunc(Cstonesize.x * _OUT_SIZER) * (act.x - 1 + x), trunc(Cstonesize.y * _OUT_SIZER) * (act.y + y - 1), rb_[act.x + x, act.y + y]);

    act.x:= act.x + x;
    act.y:= act.y + y;

    if maincnt < MAXUNDOLIST then inc(maincnt)
    else outc('dothestep() maximum UNDOs reached');
    infoout;

    case d of
      1 : outc('l');
      2 : outc('u');
      3 : outc('r');
      4 : outc('d');
    end;
    result:= true;
  end
  else begin
    if rb_[act.x + x, act.y + y] = 8 then begin
      outc('STEP [' + inttostr(oldact.x) + ',' + inttostr(oldact.y) + '] -> ['
                    + inttostr(act.x) + ',' + inttostr(act.y) + '] NOT POSSIBLE!');
    end;
    if rb_[act.x + x, act.y + y] in [2, 3] then begin   //diamant schieben
      if rb_[act.x + 2 * x, act.y + 2 * y] in [1, 4] then begin //dahinter frei?

        case d of
          1 : history[maincnt].c:= 'L';
          2 : history[maincnt].c:= 'U';
          3 : history[maincnt].c:= 'R';
          4 : history[maincnt].c:= 'D';
        end;

        oldact.x:= act.x;
        oldact.y:= act.y;

        history[maincnt].a[1].x:= act.x;
        history[maincnt].a[1].y:= act.y;
        history[maincnt].a[1].w:= rb_[act.x, act.y];

        history[maincnt].a[2].x:= act.x + x;
        history[maincnt].a[2].y:= act.y + y;
        history[maincnt].a[2].w:= rb_[act.x + x, act.y + y];

        history[maincnt].a[3].x:= act.x + 2 * x;
        history[maincnt].a[3].y:= act.y + 2 * y;
        history[maincnt].a[3].w:= rb_[act.x + 2 * x, act.y + 2 * y];

        history[maincnt].a[4].x:= act.x + 3 * x;
        history[maincnt].a[4].y:= act.y + 3 * y;
        history[maincnt].a[4].w:= rb_[act.x + 3 * x, act.y + 3 * y];

        if rb_[act.x, act.y] = 5 then rb_[act.x, act.y]:= 1          //mann -> back
        else if rb_[act.x, act.y] = 6 then rb_[act.x, act.y]:= 4;    //manlense -> lense

        if rb_[act.x + x, act.y + y] = 3 then rb_[act.x + x, act.y + y]:= 5       //diamant -> man
        else if rb_[act.x + x, act.y + y] = 2 then rb_[act.x + x, act.y + y]:= 6; //dialense -> manlense

        if rb_[act.x + 2 * x, act.y + 2 * y] = 1 then rb_[act.x + 2 * x, act.y + 2 * y]:= 3  //back -> diamant
        else if rb_[act.x + 2 * x, act.y + 2 * y] = 4 then rb_[act.x + 2 * x, act.y + 2 * y]:= 2; //lense -> dialense

        drawelement(trunc(Cstonesize.x * _OUT_SIZER) * (act.x - 1), trunc(Cstonesize.y * _OUT_SIZER) * (act.y - 1), rb_[act.x, act.y]);
        drawelement(trunc(Cstonesize.x * _OUT_SIZER) * (act.x + x - 1), trunc(Cstonesize.y * _OUT_SIZER) * (act.y + y - 1), rb_[act.x + x, act.y + y]);
        drawelement(trunc(Cstonesize.x * _OUT_SIZER) * (act.x + 2 * x - 1), trunc(Cstonesize.y * _OUT_SIZER) * (act.y + 2 * y - 1), rb_[act.x + 2 * x, act.y + 2* y]);

        act.x:= act.x + x;
        act.y:= act.y + y;

        if maincnt < MAXUNDOLIST then inc(maincnt)
        else outc('dothestep() maximum UNDOs reached');
        infoout;
        if checkdiamonds then begin
          if roomnr < rct then begin
            MessageDlg('Room finished!', mtInformation, [mbOk], 0);
            outc('dothestep( checkdiamonds() ) ROOM FINISHED!');
            if SaveSteps1.Checked then begin
              getdir(0, ss);
              if ss[length(ss)] <> '\' then ss:= ss + '\';
              savedialog1.FileName:= ss + rooms1.items[getcoll].caption + inttostr(roomnr) + '.steps';
              if savedialog1.Execute then begin
                stepfilename:= savedialog1.FileName;
                assignfile(stepfile, stepfilename);
                {$I-}
                rewrite(stepfile);
                if ioresult = 0 then begin
                  writeln(stepfile, _idstr_);
                  writeln(stepfile, version);
                  writeln(stepfile, _built_);
                  writeln(stepfile, '-=step file=-');
                  writeln(stepfile, rooms1.items[getcoll].caption + '  ' + inttostr(roomnr));
                  writeln(stepfile, inttostr(maincnt) + ' steps');
                  for i:= 0 to maincnt - 1 do writeln(stepfile, history[i].c);
                  closefile(stepfile);
                end
                else MessageDlg('[' + stepfilename + '] not written', mtError, [mbOk], 0);
              end;
            end;
            loadnext(1);
          end
          else begin
            MessageDlg('Hooray! This was the last room!', mtInformation, [mbOk], 0);
            outc('dothestep( checkdiamonds() ) LAST ROOM FINISHED!');
          end;
        end;
        case d of
          1 : outc('L');
          2 : outc('U');
          3 : outc('R');
          4 : outc('D');
        end;
        result:= true;
      end
      else begin                                    //nicht frei
        outc('SHOVE [' + inttostr(oldact.x) + ',' + inttostr(oldact.y) + '] -> ['
                      + inttostr(act.x) + ',' + inttostr(act.y) + '] NOT POSSIBLE!');
      end;
    end;
  end;
end;
(**)

begin
  a:= act.x; b:= act.y;
  case key of
     114 : begin senddrawmessage; end;
     121 : showinternals;
     122 : for i:= 0 to choose1.count - 1 do outc(bookmarks[i]);
     123 :;
     119 : begin
             form2.richedit1.clear;
             showmessage('Console cleared!');
             maincnt:= 0;
           end;
     112 : showhelp;
     113 : for i:= 1 to maincnt do outc(inttostr(i) + '  ' + history[i].c);
     65 : outc('edit1keydown() ACT.XY [' + inttostr(act.x) + ',' + inttostr(act.y) + ']');
     27 : reload;
     85 : undo;
     82 : redo;
     78 : loadnext(0);
     80 : loadprev;
     81 : close;
     32 : application.minimize;
     37 : begin
            if shift = [ssctrl] then begin
              while rb_[a - 1, b] in [1, 4] do dec(a);
              anim:= animation1.checked;
              animation1.checked:= false;
              jump((a - 1) * Cstonesize.x * 1, (b - 1) * Cstonesize.y * 1, mbleft);
              animation1.checked:= anim;
            end
            else
              if shift = [ssshift] then while dothestep(1) do
              else dothestep(1);
          end;
     38 : begin
            if shift = [ssctrl] then begin
              while rb_[a, b - 1] in [1, 4] do dec(b);
              anim:= animation1.checked;
              animation1.checked:= false;
              jump((a - 1) * Cstonesize.x * 1, (b - 1) * Cstonesize.y * 1, mbleft);
              animation1.checked:= anim;
            end
            else
              if shift = [ssshift] then while dothestep(2) do
              else dothestep(2);
          end;
     39 : begin
            if shift = [ssctrl] then begin
              while rb_[a + 1, b] in [1, 4] do inc(a);
              anim:= animation1.checked;
              animation1.checked:= false;
              jump((a - 1) * Cstonesize.x * 1, (b - 1) * Cstonesize.y * 1, mbleft);
              animation1.checked:= anim;
            end
            else
              if shift = [ssshift] then while dothestep(3) do
              else dothestep(3);
          end;
     40 : begin
            if shift = [ssctrl] then begin
              while rb_[a, b + 1] in [1, 4] do inc(b);
              anim:= animation1.checked;
              animation1.checked:= false;
              jump((a - 1) * Cstonesize.x * 1, (b - 1) * Cstonesize.y * 1, mbleft);
              animation1.checked:= anim;
            end
            else
              if shift = [ssshift] then while dothestep(4) do
              else dothestep(4);
          end;
  else
    case key of
      16 : outc('edit1keydown() = "SHIFT" ' + inttostr(key));
      17 : outc('edit1keydown() = "CTRL"  ' + inttostr(key));
      18 : outc('edit1keydown() = "ALT"   ' + inttostr(key));
    else
      outc('edit1keydown() ANY KEY ' + inttostr(key));
    end;
  end;
  edit1.text:= '';
end;

procedure TForm1.Quit1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
//  ShellAbout (0, pchar('Kohns Sokoban2'), pchar('The Sokoban game for Windows' + #13 + 'version ' + version), 0);
{
  MessageDlg('This is' + #13 + #10 +
              idstr + #13 + #10 +
              'by NKsoftware 2001', mtInformation, [mbOk], 0);
{}
//  MessageDlgPosHelp(_idstr_ + ' ' + version, mtCustom, [mbOK], -1, -1, -1, '');

(*  MessageDlgPos('This is ' + _idstr_ + ' by Norman Krebs 2002. ' + #13 + #10 +
             '' + #13 + #10 +
             'Version: ' + version + #13 + ' Build: ' + _built_ + '' + #13 + #10 +
             '' + #13 + #10 +
             'Please report bugs to: ' + #13 + #10 +
             'norman.krebs@kohnos.net and check' + #13 + #10 +
             'www.kohnos.net for the newest release of ' + _idstr_
             , mtCustom, [mbOk], 0, form1.Left + 10, form1.top + 10);
(**)
  form5.showmodal;

end;

procedure recourse(x, y, a, b, r : integer);
begin
  jb_[x, y]:= r;
  if (x = a) and (y = b) then begin
    gljmp:= true;
  end
  else begin
    if jb_[x - 1, y] in [1, 4, 5, 6] then recourse(x - 1, y, a, b, r + 1);
    if jb_[x, y - 1] in [1, 4, 5, 6] then recourse(x, y - 1, a, b, r + 1);
    if jb_[x + 1, y] in [1, 4, 5, 6] then recourse(x + 1, y, a, b, r + 1);
    if jb_[x, y + 1] in [1, 4, 5, 6] then recourse(x, y + 1, a, b, r + 1);
  end;
end;

procedure Tform1.jump(x, y : integer; button : TmouseButton);
var counter, i, j : integer;
    indik : boolean;
begin
  srce.x:= x div trunc(Cstonesize.x * _OUT_SIZER) + 1;
  srce.y:= y div trunc(Cstonesize.y * _OUT_SIZER) + 1;

  timer1.interval:= 20;

  if (button = mbleft) and (rb_[srce.x, srce.y] in [1, 4]) then begin
    dest.x:= act.x;
    dest.y:= act.y;

    for j:= 1 to 50 do
      for i:= 1 to 50 do
        jb_[i, j]:= rb_[i, j];

    gljmp:= false;
    recourse(srce.x, srce.y, dest.x, dest.y, 20);
    if gljmp then begin
      history[maincnt].a[1].x:= act.x;
      history[maincnt].a[1].y:= act.y;
      history[maincnt].a[1].w:= rb_[act.x, act.y];
      history[maincnt].a[2].x:= srce.x;
      history[maincnt].a[2].y:= srce.y;
      history[maincnt].a[2].w:= rb_[srce.x, srce.y];
      history[maincnt].a[3].x:= 1;
      history[maincnt].a[3].y:= 2;
      history[maincnt].a[3].w:= rb_[1, 2];
      history[maincnt].a[4].x:= 1;
      history[maincnt].a[4].y:= 3;
      history[maincnt].a[4].w:= rb_[1, 3];

      if maincnt < MAXUNDOLIST then inc(maincnt)
      else outc('dothestep() maximum UNDOs reached');

      if animation1.checked then begin
        outc('jump() SMOOTH [' + inttostr(dest.x) + ',' + inttostr(dest.y) + ']' +
                       ' -> [' + inttostr(srce.x) + ',' + inttostr(srce.y) + ']');

        for j:= 1 to ray[roomnr].y do
          for i:= 1 to ray[roomnr].x do
            if rb_[i, j] in [1, 4] then jb_[i, j]:= -1
            else jb_[i, j]:= -2;

        jb_[srce.x, srce.y]:= 0;
        jb_[act.x, act.y]:= -1;

        counter:= 0;

        if jb_[srce.x - 1, srce.y] = -1 then jb_[srce.x - 1, srce.y]:= 1;
        if jb_[srce.x + 1, srce.y] = -1 then jb_[srce.x + 1, srce.y]:= 1;
        if jb_[srce.x, srce.y - 1] = -1 then jb_[srce.x, srce.y - 1]:= 1;
        if jb_[srce.x, srce.y + 1] = -1 then jb_[srce.x, srce.y + 1]:= 1;

        repeat
          indik:= false;
          inc(counter);
          for j:= 1 to ray[roomnr].y do begin
            for i:= 1 to ray[roomnr].x do begin
              if jb_[i, j] = counter then begin
                indik:= true;
                if jb_[i - 1, j] = -1 then jb_[i - 1, j]:= counter + 1;
                if jb_[i + 1, j] = -1 then jb_[i + 1, j]:= counter + 1;
                if jb_[i, j - 1] = -1 then jb_[i, j - 1]:= counter + 1;
                if jb_[i, j + 1] = -1 then jb_[i, j + 1]:= counter + 1;
              end;
            end;
          end;
        until not indik;

        timer1.enabled:= true;
      end
      else begin
        outc('jump() NORMAL [' + inttostr(dest.x) + ',' + inttostr(dest.y) + ']' +
                       ' -> [' + inttostr(srce.x) + ',' + inttostr(srce.y) + ']');

        if rb_[act.x, act.y] = 5 then rb_[act.x, act.y]:= 1
        else if rb_[act.x, act.y] = 6 then rb_[act.x, act.y]:= 4;

        if rb_[srce.x, srce.y] = 1 then rb_[srce.x, srce.y]:= 5
        else if rb_[srce.x, srce.y] = 4 then rb_[srce.x, srce.y]:= 6;

        act.x:= srce.x;
        act.y:= srce.y;
        senddrawmessage;
        infoout;
      end;
    end
    else begin
      outc('jump() NOT REACHED! [' + inttostr(srce.x) + ',' + inttostr(srce.y) + ']' +
                           ' -> [' + inttostr(dest.x) + ',' + inttostr(dest.y) + ']');
    end;
  end
  else begin
    outc('jump() jb_[' + inttostr(srce.x) + ',' + inttostr(srce.y) + '] = ' + inttostr(rb_[srce.x, srce.y]) + ' jb:' + inttostr(jb_[srce.x, srce.y]));
  end;
end;

procedure TForm1.Animation1Click(Sender: TObject);
begin
  animation1.checked:= not animation1.checked;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var mn, dt : integer;
begin
  dt:= 1; //links
  if (jb_[act.x - 1, act.y] > -1) then mn:= jb_[act.x - 1, act.y]
  else mn:= 900;
  if (jb_[act.x, act.y - 1] < mn) and (jb_[act.x, act.y - 1] > -1) then begin
    dt:= 2;
    mn:= jb_[act.x, act.y - 1];
  end;
  if (jb_[act.x + 1, act.y] < mn) and (jb_[act.x + 1, act.y] > -1) then begin
    dt:= 3;
    mn:= jb_[act.x + 1, act.y];
  end;
  if (jb_[act.x, act.y + 1] < mn) and (jb_[act.x, act.y + 1] > -1) then begin
    dt:= 4;
//    mn:= jb_[act.x, act.y + 1];
  end;

  if rb_[act.x, act.y] = 5 then rb_[act.x, act.y]:= 1
  else rb_[act.x, act.y]:= 4;

  drawelement((act.x - 1) * trunc(cstonesize.x * _OUT_SIZER), (act.y - 1) * trunc(cstonesize.y * _OUT_SIZER), rb_[act.x, act.y]);

  case dt of
    1 : begin act.x:= act.x - 1; end;
    2 : begin act.y:= act.y - 1; end;
    3 : begin act.x:= act.x + 1; end;
    4 : begin act.y:= act.y + 1; end;
  end;
  if rb_[act.x, act.y] = 1 then rb_[act.x, act.y]:= 5
  else rb_[act.x, act.y]:= 6;

  if (act.x = srce.x) and (act.y = srce.y) then begin
    timer1.enabled:= false;
    outc('timer1timer() OK');
  end;

  drawelement((act.x - 1) * trunc(cstonesize.x * _OUT_SIZER), (act.y - 1) * trunc(cstonesize.y * _OUT_SIZER), rb_[act.x, act.y]);
  infoout;
end;

procedure TForm1.Undo1Click(Sender: TObject);
begin
  undo;
end;

procedure TForm1.Reload1Click(Sender: TObject);
begin
  reload;
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  showhelp;
end;

procedure TForm1.Redo1Click(Sender: TObject);
begin
  redo;
end;

procedure TForm1.Next1Click(Sender: TObject);
begin
  loadnext(0);
end;

procedure TForm1.Previous1Click(Sender: TObject);
begin
  loadprev;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key in [#13, #27] then key:= #0;
end;

procedure Tform1.loadbookmarkstomenu;
var tsr : Tsearchrec;
    NewItem, NewItem2 : Tmenuitem;
begin
  outc('BOOKMARKDIR ' + bookmarkdir);
  if findfirst(bookmarkdir + '*.bmk', faanyfile, tsr) = 0 then begin
    if (tsr.name <> '.') and (tsr.name <> '..') then begin
      outc('loadbookmarkstomenu() -1- [' + tsr.name + ']');
      NewItem:= TMenuItem.Create(Self);
      NewItem2:= TMenuItem.Create(Self);
      assignfile(bookmarkfile, bookmarkdir + tsr.name);
      reset(bookmarkfile);
      NewItem.Caption:= readline(bookmarkfile, 'itemname');
      NewItem2.Caption:= NewItem.Caption;
      closefile(bookmarkfile);
      NewItem.OnClick:= BookmarkPopMenuHandler;
      NewItem2.OnClick:= BookmarkREMPopMenuHandler;
      choose1.Add(NewItem);
      remove1.Add(NewItem2);
      bookmarks[choose1.count - 1]:= tsr.name;
    end
    else
      outc('loadbookmarkstomenu() none!');

    while findnext(tsr) = 0 do begin
      if (tsr.name <> '.') and (tsr.name <> '..') then begin
        outc('loadbookmarkstomenu() -2- [' + tsr.name + ']');
      NewItem:= TMenuItem.Create(Self);
      NewItem2:= TMenuItem.Create(Self);
      assignfile(bookmarkfile, bookmarkdir + tsr.name);
      reset(bookmarkfile);
      NewItem.Caption:= readline(bookmarkfile, 'itemname');
      NewItem2.Caption:= NewItem.Caption;
      closefile(bookmarkfile);
      NewItem.OnClick:= BookmarkPopMenuHandler;
      NewItem2.OnClick:= BookmarkREMPopMenuHandler;
      choose1.Add(NewItem);
      remove1.Add(NewItem2);
      bookmarks[choose1.count - 1]:= tsr.name;
      end;
    end;
  end
  else begin
  end;

  if choose1.count = 0 then begin
    choose1.enabled:= false;
    remove1.enabled:= choose1.enabled;
  end
  else begin
    choose1.enabled:= true;
    remove1.enabled:= choose1.enabled;
  end;
  FindClose(tsr);
end;

procedure TForm1.Add1Click(Sender: TObject);
var lne, itemname : string;
    i, j : integer;
begin
  randomize;
  repeat
    bookmarkfilename:= 'bookmark' + inttostr(random(1000)) + '.bmk';
  until not fileexists(bookmarkdir + bookmarkfilename);
  assignfile(bookmarkfile, bookmarkdir + bookmarkfilename);
  rewrite(bookmarkfile);
  closefile(bookmarkfile);
  while choose1.count > 0 do choose1.Delete(choose1.count - 1);
  while remove1.count > 0 do remove1.Delete(remove1.count - 1);
  itemname:= rooms1.items[getcoll].caption +
             ' #' + inttostr(roomnr) +
             ' (' + inttostr(maincnt) + ')' +
             ' [' + inttostr(act.x) +
              ',' + inttostr(act.y) + ']';

  outc('add1click() ' + bookmarkdir + bookmarkfilename);
  outc('itemname ' + itemname);

  append(bookmarkfile);
  writeln(bookmarkfile, 'itemname=' + itemname);
  writeln(bookmarkfile, 'roomfilename=' + rooms1.items[getcoll].caption);
  writeln(bookmarkfile, 'roomnr=' + inttostr(roomnr));
  writeln(bookmarkfile, 'maincnt=' + inttostr(maincnt));
  writeln(bookmarkfile, 'roomsize.x=' + inttostr(ray[roomnr].x));
  writeln(bookmarkfile, 'roomsize.y=' + inttostr(ray[roomnr].y));
  for j:= 1 to ray[roomnr].y do begin
    lne:= '';
    for i:= 1 to ray[roomnr].x do begin
      case rb_[i, j] of
        0 : lne:= lne + '_';
        1 : lne:= lne + ' ';
        2 : lne:= lne + '*';
        3 : lne:= lne + '$';
        4 : lne:= lne + '.';
        5 : lne:= lne + '@';
        6 : lne:= lne + '+';
        7 : lne:= lne + '_';
        8 : lne:= lne + '#';
      end;
    end;
    writeln(bookmarkfile, lne);
  end;
  for i:= 0 to maincnt - 1 do begin
    lne:= inttostr(i) + ' ';
    for j:= 1 to 4 do
      lne:= lne + ' ' + inttostr(j) + ':[' + inttostr(history[i].a[j].x) + ',' +
                                             inttostr(history[i].a[j].y) + ']=' +
                                             inttostr(history[i].a[j].w);
    lne:= lne + ' ' + history[i].c;
    writeln(bookmarkfile, lne);
  end;
  closefile(bookmarkfile);
  loadbookmarkstomenu;
end;

procedure TForm1.roominf1Click(Sender: TObject);
var i : integer;
begin
  for i:= 0 to layouts1.count - 1 do if layouts1.items[i].checked then break;
  MessageDlgPos('Room Collection: ' + roomdir + rooms1.items[getcoll].caption + #13 + #10 +
             'Rooms available: ' + inttostr(rct) + #13 + #10 +
             'Rooms solved: ' + inttostr(reached[getcoll].a) + #13 + #10 +
             'Steps gone: ' + inttostr(maincnt) + #13 + #10 +
             'Layout: ' + bmpsdir + layouts1.items[i].caption
             , mtInformation, [mbOk], 0, form1.Left + 10, form1.top + 10);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  senddrawmessage;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  jump(x, y, button);
  senddrawmessage;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  x:= x div Cstonesize.x + 1;
  y:= y div Cstonesize.y + 1;
  edit1.SetFocus;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  newgame;
  drawallelements;
  senddrawmessage;
end;

procedure TForm1.Size1Click(Sender: TObject);
begin
  form4.image1.left:= 0;
  form4.image1.top:= 0;
  form4.image1.Width:= 1000;
  form4.image1.Height:= 1000;
  form3.edit1.Text:= floattostr(_OUT_SIZER);
  form3.TrackBar1.Position:= trunc( _OUT_SIZER * 10 );
  form4.drawelement;
  form3.Left:= form1.Left + ((form1.width - form3.width) div 2);
  form3.top:= form1.top + ((form1.height - form3.height) div 2);
  form4.Left:= form3.left;
  form4.top:= form3.Top + form3.height;
  form4.show;
  form3.showmodal;
end;

procedure TForm1.Logging1Click(Sender: TObject);
begin
  Logging1.Checked:= not Logging1.Checked;
end;

procedure TForm1.SaveSteps1Click(Sender: TObject);
//var i : integer;
begin
  SaveSteps1.Checked:= not SaveSteps1.Checked;
end;

end.





























