{#############################################################################
#                _         _                  _____                          #
#               | |       | |                / __  \                         #
#      ___  ___ | | _____ | |__   __ _ _ __  `' / /'                         #
#     / __|/ _ \| |/ / _ \| '_ \ / _` | '_ \   / /                           #
#     \__ \ (_) |   < (_) | |_) | (_| | | | |./ /___                         #
#     |___/\___/|_|\_\___/|_.__/ \__,_|_| |_|\_____/                         #
#                                                                            #
#  Kohn's Sokoban2                                                           #
#                                                                            #
#  Copyright (C) 2001  Norman Krebs                                          #
#                                                                            #
#    This program is free software; you can redistribute it and/or           #
#    modify it under the terms of the GNU General Public License as          #
#    published by the Free Software Foundation; either version 2 of          #
#    the License, or (at your option) any later version.                     #
#                                                                            #
#    This program is distributed in the hope that it will be useful,         #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of          #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        #
#    General Public License for more details.                                #
#                                                                            #
#    You should have received a copy of the GNU General Public License       #
#    along with this program; if not, write to the Free Software             #
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
#                                                                            #
#############################################################################}
unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls;

type
  TForm2 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    SaveDialog1: TSaveDialog;
    RichEdit1: TRichEdit;
    Clear: TMenuItem;
    LineNumbers1: TMenuItem;
    procedure Save1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure LineNumbers1Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form2 : TForm2;
  showlinenumbers : boolean = false;

implementation

{$R *.DFM}

uses unit1;

procedure TForm2.Save1Click(Sender: TObject);
begin
  if savedialog1.Execute then begin
    richedit1.Lines.SaveToFile(savedialog1.filename);
    MessageDlg('Messages saved to: ' + savedialog1.filename, mtInformation, [mbOk], 0);
  end;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  if paramcount > 0 then form2.richedit1.Lines.SaveToFile(workdir + 'temp.txt');
end;

procedure TForm2.ClearClick(Sender: TObject);
begin
  form2.RichEdit1.Clear;
  maincnt:= 0;
end;

procedure TForm2.LineNumbers1Click(Sender: TObject);
var s : string;
begin
  showlinenumbers:= not showlinenumbers;
  if showlinenumbers then s:= 'ON' else s:= 'OFF';
  LineNumbers1.Caption:= 'Line Numbers = ' + s;
end;

end.
