{#############################################################################
#                _         _                  _____                          #
#               | |       | |                / __  \                         #
#      ___  ___ | | _____ | |__   __ _ _ __  `' / /'                         #
#     / __|/ _ \| |/ / _ \| '_ \ / _` | '_ \   / /                           #
#     \__ \ (_) |   < (_) | |_) | (_| | | | |./ /___                         #
#     |___/\___/|_|\_\___/|_.__/ \__,_|_| |_|\_____/                         #
#                                                                            #
#  Kohn's Sokoban2                                                           #
#                                                                            #
#  Copyright (C) 2001  Norman Krebs                                          #
#                                                                            #
#    This program is free software; you can redistribute it and/or           #
#    modify it under the terms of the GNU General Public License as          #
#    published by the Free Software Foundation; either version 2 of          #
#    the License, or (at your option) any later version.                     #
#                                                                            #
#    This program is distributed in the hope that it will be useful,         #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of          #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        #
#    General Public License for more details.                                #
#                                                                            #
#    You should have received a copy of the GNU General Public License       #
#    along with this program; if not, write to the Free Software             #
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
#                                                                            #
#############################################################################}
unit Unit3;

interface

uses
  unit1, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm3 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form3: TForm3;

implementation

uses Unit4;

{$R *.DFM}

procedure TForm3.Button1Click(Sender: TObject);
var i : integer;
    k : real;
    s : string;
begin
  s:= edit1.text;
  k:= _OUT_SIZER;
  for i:= 1 to length(s) do if s[i] = '.' then s[i]:= ',';
  _OUT_SIZER:= strtofloat(s);
  if _OUT_SIZER < 0.5 then _OUT_SIZER:= 0.5;
  form1.paintbox1.width:= trunc(50 * Cstonesize.x * _OUT_SIZER);
  form1.paintbox1.height:= trunc(50 * Cstonesize.y * _OUT_SIZER);
  form1.panel1.width:= (ray[roomnr].x + 1) * trunc(Cstonesize.x * _OUT_SIZER);
  form1.panel1.height:= (ray[roomnr].y + 1) * trunc(Cstonesize.y * _OUT_SIZER);
  form1.AutoSize:= true;
  sendmessage(form1.Handle, wm_Paint, 0, 0);
  form3.close;
  form4.close;
  outc('size changed from ' + floattostr(k) + ' to ' + floattostr(_OUT_SIZER));
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  form3.close;
  form4.close;
end;

procedure TForm3.TrackBar1Change(Sender: TObject);
begin
  edit1.text:= floattostr(trackbar1.position / 10);
  form4.panel1.Caption:= '';
  form4.drawelement;
end;

procedure TForm3.Edit1Change(Sender: TObject);
var i : integer;
    s : string;
begin
  s:= edit1.text;
  if s <> '' then begin
    for i:= 1 to length(s) do if s[i] = '.' then s[i]:= ',';
    form3.TrackBar1.Position:= trunc( strtofloat(s) * 10 );
    form4.drawelement;
  end;
end;

end.
